#include <bits/stdc++.h>
#define ll long long
using namespace std;
ll N, n[200005], T, K, TrK;
int main(){
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    cin >> T >> N >> K;
    for(int i = 1; i <= N; i++) cin >> n[i];
    for(int i = 1; i <= N; i++){
        if(TrK <= n[i]) TrK++;
        else TrK--;
    }
    if(TrK == K){
        cout << "DA" << endl;
        for(int i = 1; i <= N; i++) cout << n[i] << " ";
    }else{
        cout << "NE" << endl;
    }



return 0;
}